;                      3.1
;        ஫, । 
;  ⮢⥫, ᯮ㥬 ᭮ ࠭⢠
;                 뢠 IRQ
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst_3_01.asm, 12.03.2000.

IDEAL
P386
LOCALS
MODEL MEDIUM

;  䠩 ᪨ 祭 梥⮢
include "lst_1_05.inc"

SEGMENT sseg para stack 'STACK'
DB 400h DUP(?)
ENDS

DATASEG
; ࠬ ன⢠ PCI
VendorID       DW ? ;䨪 ⮢⥫
DeviceID       DW ? ;䨪 ன⢠
ClassCode      DD ? ;⨯ ன⢠
BaseAddress0   DD ? ;  0
BaseAddress1   DD ? ;  1
BaseAddress2   DD ? ;  2
BaseAddress3   DD ? ;  3
BaseAddress4   DD ? ;  4
BaseAddress5   DD ? ;  5
InterruptLine  DB ? ; ᯮ㥬 뢠 IRQ
; न ன⢠ PCI
BusNumber      DB ? ; 設
DeviceNumber   DB ? ; ன⢠   㭪樨
; 稪 権 /᪠ 
PressCounter DW ?
; ⮢ ᮮ饭
PCI DB 0,25,"஢ 㭪権 PCI BIOS",0
    DB 4,20,"ࠬ 㦥 ஫",0
    DB 6,0," 設:",0
    DB 7,0," ன⢠:",0
    DB 8,0," 㭪樨:",0
    DB 9,0,"䨪 ⮢⥫:",0
    DB 10,0,"䨪 ன⢠:",0
    DB 11,0," ன⢠:",0
    DB 12,0,"  0:",0
    DB 13,0,"  1:",0
    DB 14,0,"  2:",0
    DB 15,0,"  3:",0
    DB 16,0,"  4:",0
    DB 17,0,"  5:",0
    DB 18,0," ᯮ㥬 뢠:",0
    DB 24,29,"  ",0
; 饭  ⮬,  뢠  ᯮ
NoIRQ DB 18,32," ᯮ",0
; 饭  訡
NotPCI DB LIGHTRED,12,18
       DB "⥬  ন 䥩 PCI BIOS",0
NotSVGA DB LIGHTRED,12,22
        DB "஫ SVGA PCI  ",0
BadRegister DB LIGHTRED,12,22
            DB "  ॣ",0
Exit DB LIGHTRED,24,17
     DB " 室  ணࠬ   ",0
ENDS

CODESEG
;*****************************
;* ᭮  ணࠬ *
;*****************************
PROC PCITest
        mov     AX,DGROUP
        mov     DS,AX
; ⠭ ⥪⮢ ०   ࠭
        mov     AX,3
        int     10h
;   -    ࠭ ࠭
        mov     [ScreenString],25
        mov     [ScreenColumn],0
        call    SetCursorPosition
; ⠭  梥 ᨬ   䮭
        mov     [TextColorAndBackground],LIGHTGREEN
; 뢥 ⥪⮢ ᮮ饭  ࠭
        mov     CX,16
        mov     SI,offset PCI
@@NextString:
        call    ShowString
        loop    @@NextString
; ⠭  梥 ᨬ   䮭
        mov     [TextColorAndBackground],YELLOW

;  PCI-ன
; ஢ 稥 PCI BIOS
        mov     AX,0B101h
        int     1Ah
        jc      @@PCIBIOSNotFound
        cmp     EDX,20494350h
        jne     @@PCIBIOSNotFound

;  ஫ ( ࢮ
; ன⢮ ⨯ 30000h)
        mov     AX,0B103h
        mov     ECX,030000h
        mov     SI,0
        int     1Ah
        jc      @@DeviceNotFound
        mov     [BusNumber],BH
        mov     [DeviceNumber],BL

;  䨪 ⮢⥫
        mov     AX,0B109h ; ᫮
        mov     DI,0      ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [VendorID],CX
;  䨪 ன⢠
        mov     AX,0B109h ; ᫮
        mov     DI,2      ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [DeviceID],CX
;  ⨯ ன⢠ (ᠬ஢ઠ)
        mov     AX,0B10Ah ;  ᫮
        mov     DI,8      ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        shr     ECX,8
        mov     [ClassCode],ECX
;    0
        mov     AX,0B10Ah ;  ᫮
        mov     DI,10h    ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [BaseAddress0],ECX
;    1
        mov     AX,0B10Ah ;  ᫮
        mov     DI,14h    ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [BaseAddress1],ECX
;    2
        mov     AX,0B10Ah ;  ᫮
        mov     DI,18h    ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [BaseAddress2],ECX
;    3
        mov     AX,0B10Ah ;  ᫮
        mov     DI,1Ch    ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [BaseAddress3],ECX
;    4
        mov     AX,0B10Ah ;  ᫮
        mov     DI,20h    ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [BaseAddress4],ECX
;    5
        mov     AX,0B10Ah ;  ᫮
        mov     DI,24h    ;ᬥ饭 ᫮
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [BaseAddress5],ECX

;   ᯮ㥬 ன⢮
; 뢠 IRQ
        mov     AX,0B108h ; 
        mov     DI,3Ch    ;ᬥ饭 
        int     1Ah
        jc      @@BadRegisterNumber
        mov     [InterruptLine],CL

; 뢥 祭   ࠭ 
; ⭠筮 
        ; ⮡ࠧ ᭮ ࠬ ன⢠
        mov     [ScreenString],6
        mov     [ScreenColumn],12
        mov     AL,[BusNumber]
        call    ShowByteHexCode

        inc     [ScreenString]
        mov     [ScreenColumn],18
        mov     AL,[DeviceNumber]
        shr     AL,3
        call    ShowByteHexCode

        inc     [ScreenString]
        mov     [ScreenColumn],15
        mov     AL,[DeviceNumber]
        and     AL,111b
        call    ShowByteHexCode

        inc     [ScreenString]
        mov     [ScreenColumn],28
        mov     AX,[VendorID]
        call    ShowHexWord

        inc     [ScreenString]
        mov     [ScreenColumn],26
        mov     AX,[DeviceID]
        call    ShowHexWord

        inc     [ScreenString]
        mov     [ScreenColumn],16
        mov     EAX,[ClassCode]
        call    ShowHexDWord

        ; ⮡ࠧ  
        inc     [ScreenString]
        mov     [ScreenColumn],17
        mov     EAX,[BaseAddress0]
        call    ShowHexDWord

        inc     [ScreenString]
        mov     [ScreenColumn],17
        mov     EAX,[BaseAddress1]
        call    ShowHexDWord

        inc     [ScreenString]
        mov     [ScreenColumn],17
        mov     EAX,[BaseAddress2]
        call    ShowHexDWord

        inc     [ScreenString]
        mov     [ScreenColumn],17
        mov     EAX,[BaseAddress3]
        call    ShowHexDWord

        inc     [ScreenString]
        mov     [ScreenColumn],17
        mov     EAX,[BaseAddress4]
        call    ShowHexDWord

        inc     [ScreenString]
        mov     [ScreenColumn],17
        mov     EAX,[BaseAddress5]
        call    ShowHexDWord

        ; 뢥  ᯮ㥬 뢠 IRQ
        inc     [ScreenString]
        mov     [ScreenColumn],32
        mov     AL,[InterruptLine]
        cmp     AL,0FFh      ;뢠 ᯮ?
        je      @@IRQNotUsed
        call    ShowByteHexCode
        jmp short @@End
@@IRQNotUsed:
        mov     SI,offset NoIRQ
        call    ShowString
        jmp short @@End

; ࠡ⪠ 訡
@@BadRegisterNumber:
        ;   ॣ
        mov     SI,offset BadRegister
        jmp     @@ErrorMessage
@@DeviceNotFound:
        ;   ஫
        mov     SI,offset NotSVGA
        jmp     @@ErrorMessage
@@PCIBIOSNotFound:
        ;  ন PCI BIOS
        mov     SI,offset NotPCI
@@ErrorMessage:
        ; 뤠 ᮮ饭  ⨯ 訡
        call    ClearScreen
        call    ShowColorString
        mov     SI,offset Exit
        call    ShowColorString

; 砭 ࠡ
@@End:  ;    
        call    GetChar
; ⠭ ⥪⮢ ०   ࠭
        mov     AX,3
        int     10h
; 室  DOS
        mov     AH,4Ch
        int     21h
ENDP PCITest 
ENDS

;  楤 뢮   ࠭
include "lst_1_02.inc"

END

