;                      4.19
;    "ᠫ" ணࠬ, ਣ   
;  ࠭筮, ⠪   ࠭筮 ०
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst_4_19.inc, 01.04.2000

CODESEG
;**************************************************
;*                *
;* ணࠬ 뢮 ᮤন ॣ AL    *
;*  筮   㪠  ࠭.  *
;* न 樨 । १  *
;* ६ ScreenString  ScreenColumn.        *
;**************************************************
PROC GShowDecByte NEAR
        push    EAX
        and     EAX,0FFh
        call    GShowDecDWord
        pop     EAX
        ret
ENDP GShowDecByte


;*****************************************************
;*          16-           *
;*                                    *
;* ࠬ:                                        *
;* AX - ᫮, ஥ 㤥 뢥  ࠭.      *
;*  ப । १           *
;* ६ ScreenString,  ⮫ - १    *
;* ६ ScreenColumn, 梥 ⥪ । *
;* 쭮 ६ TextColorAndBackground.      *
;*****************************************************
PROC GShowDecWord NEAR
        push    EAX
        and     EAX,0FFFFh
        call    GShowDecDWord
        pop     EAX
        ret
ENDP GShowDecWord


;*****************************************************
;*          32-           *
;*                                    *
;* ࠬ:                                        *
;* EAX - ᫮, ஥ 㤥 뢥  ࠭.     *
;*  ப । १           *
;* ६ ScreenString,  ⮫ - १    *
;* ६ ScreenColumn, 梥 ⥪ । *
;* 쭮 ६ TextColorAndBackground.      *
;*****************************************************
PROC GShowDecDWord NEAR
        pushad
        push    DS
; ந ॣ DS   ᥣ 
        mov     SI,DGROUP
        mov     DS,SI
; ॢ ᫮   
        mov     [Data_Int32],EAX
        call    Int32_to_String
        mov     DH,[byte ptr ScreenString]
        mov     DL,[byte ptr ScreenColumn]
; 뢥 ᫮  ࠭
        mov     CX,10
        mov     SI,offset Data_String
@@NextChar:
        lodsb             ;㧨   AL
        and     AL,AL     ;஢ઠ  0 ( ப)
        jz      @@EndOfString
        call    PutGraChar
        loop    @@NextChar
@@EndOfString:
        pop     DS
        popad
        ret
ENDP GShowDecDWord


;*******************************************************
;*        *
;* (ᯮ⥫쭠 楤, ॣ  ࠭)  *         
;*******************************************************
PROC InitEpisode near
; ᮢ 䮭
        call    ShowBackground
;  砫  ࠦ ꥪ⮢
        mov     [PlnA],0
        mov     [RktA],0
        mov     [FlmA],0
        mov     [ExpA],0
;  ਧ  ꥪ⮢
        mov     [PlnF1],0
        mov     [RktF1],0
        mov     [FlmF1],0
        mov     [ExpF1],0
;  稪 ६
        mov     [GameTimeCounter],0
;  ਧ  ࠪ  ᠬ
        mov     [HitFlag],0
; ⠭ 砫쭮 ﭨ ᠬ
        mov     [PlnState],0
        ; ਡ 砩 ᬥ饭  
        mov     BX,[EpisodeNumber]
        shl     BX,2
        add     BX,offset DeltaS
        mov     EAX,[BX]
        add     EAX,80
        mov     [PlnS],EAX
        ;  ࠢ  ᠬ
        mov     BX,[EpisodeNumber]
        add     BX,offset Direction
        mov     AL,[BX]
        mov     [PlaneDirection],AL
        ; ᫨ ᪮ ᠬ
        mov     BX,[EpisodeNumber]
        shl     BX,2
        add     BX,offset PlnSpeed
        mov     EAX,[BX]
        mov     [PlaneSpeed],EAX
        ; প ᪠ ᠬ
        mov     BX,[EpisodeNumber]
        shl     BX,2
        add     BX,offset DeltaT
        mov     AX,[BX]
        mov     [PlaneDeltaT],AX
        ; ஢  ᠬ
        call    CopyPlaneMask
        ;  ᠬ   ࠭ ࠭
        mov     [PlnC],-PlnML
        ; ࠢ ?
        cmp     [PlaneDirection],0
        je      @@dir0
        ;  ᠬ  ࠢ ࠭ ࠭
        mov     [PlnC],ScreenLength
        ; "⥫쭠" ᪮
        neg     [PlaneSpeed]
        ; ᯮ짮 ࠦ 
        call    MirrorPlaneMask
; ⠭ 砫쭮 ﭨ ࠪ
@@dir0: mov     [RktState],0 ;ﭨ 0
        ; ⮡ࠧ ࠪ  ⮢ 樨
        mov     [RktF1],1  ;⮡ࠧ ࠪ
        mov     EAX,[PRS]  ;न ⮢ 樨
        mov     [RktS],EAX
        mov     EAX,[PRC]
        mov     [RktC],EAX
        ret
ENDP InitEpisode


;**************************
;*    *
;**************************
PROC ShowGameResults near
        pushad
;  ࠭
        call    GClearScreen
; ⮡ࠧ १
        mov     SI,offset EndTxt
        mov     [DefaultColor],LIGHTCYAN
        call    GShowString
        mov     [DefaultColor],LIGHTGREEN
        call    GShowString
        call    GShowString
        call    GShowString
        call    GShowString
        mov     [DefaultColor],YELLOW
        call    GShowString
        mov     [DefaultColor],WHITE
        mov     [ScreenString],12
        mov     [ScreenColumn],18
        mov     AX,[EpisodeNumber]
        call    GShowDecWord
        mov     [ScreenString],14
        mov     [ScreenColumn],16
        mov     AX,[RktCounter]
        call    GShowDecWord
        mov     [ScreenString],16
        mov     [ScreenColumn],17
        mov     AX,[DestroedPlns]
        call    GShowDecWord
        mov     [ScreenString],18
        mov     [ScreenColumn],21
        mov     AX,[EscPlns]
        call    GShowDecWord
;    
        call    GetChar
        popad
        ret
ENDP ShowGameResults


;************************
;*    *
;************************
PROC DrawMainBackground near
        pushad
; 㧨 砫쭮 ᬥ饭 ( ࠭)
        mov     EDI,VPage0Address
;   "" ( ࠭  64 ப)
;   ਭ ப (1024 ᥫ)
        mov     ECX,ScreenHeigth-64
        shl     ECX,10
;    ᨭ 梥
        mov     AL,BLUE
@@NextPixel1:
        mov     [GS:EDI],AL
        inc     EDI
        dec     ECX
        jnz     @@NextPixel1
;       梥
        mov     AL,BLACK
        mov     AH,GREEN
;  "" 64 ப
        mov     DX,64
@@NextStr:
        mov     CX,LogicalStringLength/2
@@NextPixel2:
        mov     [GS:EDI],AX
        add     EDI,2
        loop    @@NextPixel2
        xchg    AL,AH
        dec     DX
        jnz     @@NextStr

;  
        ; 砫쭠 ப ""
        mov     [dword ptr TreeS],ScreenHeigth-80
        ; ᫮ 冷 ॢ쥢
        mov     DX,4
;  ᮢ 
@@Trees:; ᮢ ।  ॢ쥢
        mov     [dword ptr TreeC],0
        test    DX,01b
        jz      @@EvenLine
        ;   
        add     [dword ptr TreeC],16
@@EvenLine:
        mov     CX,ScreenLength/(TreeML*2)
@@NextTree:
        cmp     CX,ScreenLength/(TreeML*4)
        je      @@NoTree ;"ᥪ"  
        cmp     CX,ScreenLength/(TreeML*4)+1
        je      @@NoTree ;"ᥪ"  
        ; ᮢ । ॢ
DrawSImage TreeS,TreeC,TreeML,TreeMH,Tree
@@NoTree:
        add     [dword ptr TreeC],TreeML*2
        loop    @@NextTree
        add     [dword ptr TreeS],TreeMH/2
        dec     DX
        jnz     @@Trees

;  
        mov     BX,offset CloudPos
        mov     CX,MaxCloudNum ;稪 
@@NextCloud:
        ; ᮢ । 
        mov     EAX,[BX]
        mov     [CloudS],EAX
        add     BX,4
        mov     EAX,[BX]
        mov     [CloudC],EAX
        add     BX,4
DrawSImage CloudS,CloudC,CloML,CloMH,Cloud
        loop    @@NextCloud

;   
        mov     [PRS],ScreenHeigth-PRMH-16
        mov     [PRC],(ScreenLength-PRML)/2
DrawSImage PRS,PRC,PRML,PRMH,Platf
        popad
        ret
ENDP DrawMainBackground


;******************************
;*    *
;******************************
PROC CopyPlaneMask near
        pusha
        push    ES
        mov     AX,DGROUP
        mov     ES,AX
        mov     SI,offset Plane
        mov     DI,offset PlnMask
        ; ஢  ᨢ
        mov     CX,PlnMH*PlnML
        rep     movsb
        pop     ES
        popa
        ret
ENDP CopyPlaneMask


;*************************************
;*     *
;*************************************
PROC MirrorPlaneMask near
        pusha
        mov     SI,offset Plane
        mov     DI,offset PlnMask
        mov     DX,PlnMH
;   ப
@@L0:   mov     CX,PlnML
        add     DI,PlnML-1
;   ᥫ
@@L1:   lodsb
        mov     [DI],AL
        dec     DI
        loop    @@L1
        add     DI,PlnML+1
        dec     DX
        jnz     @@L0
        popa
        ret
ENDP MirrorPlaneMask


;************************
;*    *
;************************
PROC ExpMaskClear near
        pusha
        push    ES
        mov     AX,DGROUP
        mov     ES,AX
        mov     DI,offset ExpMask
        mov     CX,4*ExpR*ExpR
        mov     AL,0
        rep     stosb
        pop     ES
        popa
        ret
ENDP ExpMaskClear


;******************************************
;*      *
;******************************************
PROC ExplosionFrame near
        pusha
        cld
; 뢥 ࠦ 뢠
        ;   ᨢ ᬥ饭 ᪮
        mov     SI,offset SplStep
        ;  ᫮ ᪮
        mov     CX,SplinterMaxNumber
@@NextSplinter:
; 㧨  DI 㪠⥫   뢠
        mov     DI,offset ExpMask
;  蠣  Y    ( 1)
        lodsb         ; 蠣  Y  AL
        mov     AH,[byte ptr ExpFrameNumber]
        inc     AH    ;㢥    1
        imul    AH    ;㬭 蠣   
        ; ਡ  ப 業 ᪨
        add     AX,ExpR-1
        ;  ࠧ   ப ᪨ 
        mov     DX,2*ExpR
        mul     DX
        ; ਡ १  ᬥ饭  ᪥
        add     DI,AX
;  蠣  X    ( 1)
        lodsb         ; 蠣  X  AL
        mov     AH,[byte ptr ExpFrameNumber]
        inc     AH    ;㢥    1
        imul    AH    ;㬭 蠣   
        ; ਡ   業 ᪨
        add     AX,ExpR-1
        ; ਡ १  ᬥ饭  ᪥
        add     DI,AX
;  -᪮  
        mov     BX,offset ExpColors
        add     BX,[ExpFrameNumber]
        mov     AL,[BX]
        mov     [DI],AL
        loop    @@NextSplinter
        popa
        ret
ENDP ExplosionFrame
ENDS
