;                      5.5
;      ணࠬ, ⠭  ࠡ稪 
;    뢠  PS/2,  ⮡ࠦ 
;      ⥪⮢ ० ᨥ ਡ ᨬ
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst_5_05.asm, 06.04.2000

IDEAL
P386
LOCALS
MODEL MEDIUM

;  䠩 ᪨ 祭 梥⮢
include "lst_1_05.inc"

SEGMENT sseg para stack 'STACK'
DB 400h DUP(?)
ENDS

ScreenLength equ 80
ScreenWidth  equ 25

DATASEG
;  ࠭ ண  뢠 
OldPS2MouseInterruptOffset  DW ?
OldPS2MouseInterruptSegment DW ?
;  ਭ   
MouseByteNumber DB 0
; 塠⮢  , । 
FirstByte       DB 0
SecondByte      DB 0
ThirdByte       DB 0
; 饥 ﭨ 
ButtonsStatus   DB 0
; 騥 न  
XCoordinate     DW 0
YCoordinate     DW 0
; ।   
OldXCoordinate  DW 0
OldYCoordinate  DW 0
; ஥ 祭 䮭 ᨬ
OldCharBackground DB 0Fh
; ⮢ ᮮ饭
Txt DB LIGHTGREEN,0,28,"   PS/2-⨯",0
    DB WHITE,12,14,"⮡ࠦ  "
    DB " ᨥ ਡ ᨬ",0
    DB YELLOW,24,21
    DB " 室    ",0
ErrTxt DB LIGHTRED,11,22
       DB "訡  묨   PS/2!",0
       DB LIGHTRED,13,20
       DB "஢ ࠢ쭮 祭 .",0
       DB YELLOW,24,22
       DB "    ",0
ENDS


CODESEG
;*****************************
;* ᭮  ணࠬ *
;*****************************
PROC PS2MouseStart
        mov     AX,DGROUP
        mov     DS,AX
; ⠭ ⥪⮢ ०   ࠭
        mov     AX,3
        int     10h
;  ⥪⮢  -  
;  ࠭ ࠭
        mov     [ScreenString],25
        mov     [ScreenColumn],0
        call    SetCursorPosition
; 뢥 ⥪⮢ ᮮ饭  ࠭
        mov     SI,offset Txt
        call    ShowColorString
        call    ShowColorString
        call    ShowColorString

;    IRQ12
        ;  ७ ॣ  i8042
        call    Wait8042BufferEmpty
        mov     AL,020h
        out     64h,AL
        in      AL,60h
        ; ࠭ ᮤন ॣ   AH
        mov     AH,AL
        ;  ७ ॣ  i8042
        call    Wait8042BufferEmpty
        mov     AL,060h
        out     64h,AL
        ;  ᨣ 뢠  
        mov     AL,AH
        and     AL,11111101b
        out     60h,AL

;     
        call    Wait8042BufferEmpty
        mov     AL,0D4h ;᫠   
        out     64h,AL
        call    Wait8042BufferEmpty
        mov     AL,0F4h ;ࠧ । 
        out     60h,AL
;   ⢥ত ਥ 
        call    WaitMouseData
        jz      @@DataInputError ;  㯨
        in      AL,60h
        ; 祭 ⢥ত ਥ ?
        cmp     AL,0FAh          
        jnz     @@DataInputError ; ⢥ত

;    IRQ12
;  ७ ॣ  i8042
        call    Wait8042BufferEmpty
        mov     AL,020h
        out     64h,AL
        in      AL,60h 
;  ७ ॣ  i8042
        mov     AH,AL
        call    Wait8042BufferEmpty
        mov     AL,060h
        out     64h,AL
;  ᨣ 뢠  
        mov     AL,AH
        or      AL,10b
        out     60h,AL 

;    
; 㫨   
        mov     [XCoordinate],0
        mov     [YCoordinate],0
        mov     [OldXCoordinate],0
        mov     [OldYCoordinate],0
; ⮡ࠧ    ࠧ
        call    ShowNewMouseCursorPosition
; ⠭  ࠡ稪 뢠
        call    SetPS2MouseInterrupt
; ,     
@@Next: test    [ButtonsStatus],1b
        jz      @@Next
        jmp short @@End

@@DataInputError:
        call    ClearScreen
        mov     SI,offset ErrTxt
        call    ShowColorString
        call    ShowColorString
        call    ShowColorString
        call    GetChar

;   
@@End:
; ⠭ ० ࠡ稪 뢠
        call    RestoreOldPS2MouseInterrupt
; 室  DOS
        mov     AH,4Ch
        int     21h
ENDP PS2MouseStart


;**************************************
;*     PS/2 *
;**************************************
proc PS2MouseInterrupt far
        sti     ;ࠧ ᪨㥬 뢠
        pusha
        push    DS
        mov     AX,DGROUP
        mov     DS,AX
        call    Wait8042BufferEmpty ;⪠ 
        in      AL,60h              ; -

; 롨 浪  ਭ 
        cmp     [MouseByteNumber],0
        je      @@SaveFirstByte
        cmp     [MouseByteNumber],1
        je      @@SaveSecondByte
        cmp     [MouseByteNumber],2
        je      @@SaveThirdByte
        jmp     @@Error
;    뫪
@@SaveFirstByte:
        test    AL,1000b    ;  뫪?
        jz      @@Error     ;ᡮ ᨭ஭樨
        mov     [FirstByte],AL
        inc     [MouseByteNumber]
        jmp     @@EndMouseInterrupt
;  ன  뫪
@@SaveSecondByte:
        mov     [SecondByte],AL
        inc     [MouseByteNumber]
        jmp     @@EndMouseInterrupt
;  ⨩  뫪
@@SaveThirdByte:
        mov     [ThirdByte],AL
        mov     [MouseByteNumber],0
; (    ਭ )

;   祭  ﭨ 
        mov     AL,[FirstByte]
        and     AL,0111b
        mov     [ButtonsStatus],AL
; ᫨  X-न 
        ;   AX ६饭  X
        mov     AH,0   ;㡫㥬    ࠧ AH
        mov     AL,[FirstByte]
        test    AL,10000b     
        jz      @@M0
        mov     AH,0FFh
        ;   AL 訩 
@@M0:   mov     AL,[SecondByte]
        ; ᫨  祭 न
        ;   X
        add     AX,[XCoordinate]
        cmp     AX,0
        jge     @@M1
        mov     AX,0
        jmp short @@M2
@@M1:   cmp     AX,ScreenLength
        jl      @@M2
        mov     AX,ScreenLength-1
@@M2:   mov     [XCoordinate],AX

; 塞  Y-न 
        ;   AX ६饭  Y
        mov     AH,0   ;㡫㥬    ࠧ AH
        mov     AL,[FirstByte]
        test    AL,100000b
        jz      @@M3
        mov     AH,0FFh
        ;   AL 訩 
@@M3:   mov     AL,[ThirdByte]
        ; ᫨  祭 न 
        ;  Y (Y-न  PS/2 ࠢ
        ; ⨢ ࠭)
        neg     AX  
        add     AX,[YCoordinate]
        cmp     AX,0
        jge     @@M4
        mov     AX,0
        jmp short @@M5
@@M4:   cmp     AX,ScreenWidth
        jl      @@M5
        mov     AX,ScreenWidth-1
@@M5:   mov     [YCoordinate],AX

;     樨
        call    ShowNewMouseCursorPosition
        jmp short @@EndMouseInterrupt

; 㦥 ᡮ  浪 । ଠ樨  
@@Error:
        mov   [MouseByteNumber],0
; ଠ쭮 襭 뢠
@@EndMouseInterrupt:
        cli
        ; ࠧ襭 뢠  訬 ਮ⠬
        mov     AL,20h              
        out     0A0h,AL ; EOI  i8059-2
        out     20h,AL  ; EOI  i8059-1
        pop     DS
        popa
        iret                        
endp PS2MouseInterrupt 


;******************************************* 
;*      *
;******************************************* 
PROC SetPS2MouseInterrupt NEAR
        pusha
        push    ES
        mov     AX,0
        mov     ES,AX
;  ०  ࠡ稪
; 뢠 
        mov     AX,[ES:74h*4]
        mov     [OldPS2MouseInterruptOffset],AX
        mov     AX,[ES:74h*4+2]
        mov     [OldPS2MouseInterruptSegment],AX
; ⠭   뢠
        cli     ; 뢠
        mov     AX,offset PS2MouseInterrupt
        mov     [ES:74h*4],AX
        mov     AX,CS
        mov     [ES:74h*4+2],AX
        sti     ;ࠧ 뢠
; ᪨஢ 뢠 IRQ12
        in      AL,0A1h
        and     AL,11101111b
        jmp short $+2      ;প
        jmp short $+2      ;প
        out     0A1h,AL
        pop     ES
        popa
        ret
ENDP SetPS2MouseInterrupt


;**********************************************
;*      *      
;**********************************************
PROC RestoreOldPS2MouseInterrupt NEAR
        pusha
        push    ES
        mov     AX,0
        mov     ES,AX
; ⠭ ०  ࠡ稪 뢠
        cli
        mov     AX,[OldPS2MouseInterruptOffset]
        mov     [ES:74h*4],AX
        mov     AX,[OldPS2MouseInterruptSegment]
        mov     [ES:74h*4+2],AX
        sti
        pop     ES
        popa
        ret
ENDP RestoreOldPS2MouseInterrupt


;*******************************************
;*      *
;*           *
;*******************************************
PROC ShowNewMouseCursorPosition NEAR
        pusha
        push    ES
; ந ES  ⥪⮢ 
        mov     AX,0B800h
        mov     ES,AX
; ᫨  ।饩 樨  
        mov     AX,[OldYCoordinate]
        mov     DX,160
        mul     DX
        add     AX,[OldXCoordinate]
        add     AX,[OldXCoordinate]
        inc     AX
        ;  ᬥ饭   ॣ
        mov     DI,AX
        ; ⠭ 室 ਡ ᨬ
        mov     AL,[OldCharBackground]
        mov     [ES:DI],AL
; ᫨   樨  
        mov     AX,[YCoordinate]
        mov     DX,160
        mul     DX
        add     AX,[XCoordinate]
        add     AX,[XCoordinate]
        inc     AX
        ;  ᬥ饭   ॣ
        mov     DI,AX
        ; ࠭ 祭 ਡ ᨬ
        mov     AL,[ES:DI]
        mov     [OldCharBackground],AL
        ; ஢ ਡ ᨬ (஬
        ; 襣 ࠧ鸞)
        xor     [byte ptr ES:DI],1111111b
        ;  न 
        mov     AX,[XCoordinate]
        mov     [OldXCoordinate],AX
        mov     AX,[YCoordinate]
        mov     [OldYCoordinate],AX
        pop     ES
        popa
ENDP ShowNewMouseCursorPosition
ENDS

;  楤 뢮   ࠭
include "lst_1_02.inc"
;  楤 ⪨ 室 
; ஫    㯫
;   
include "lst_5_03.inc"

END
