;                      6.4
;        뢮  ࠭ 256-梥⭮ PCX-䠩
;                 ० TrueColor32
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst_6_04.asm, 19.04.2000.

IDEAL
P386
LOCALS
MODEL MEDIUM

;  ० ࠭  ⥭
GraphicsMode equ 0
; ᪠ ਭ ப  ᥫ
LogicalStringLength equ 1024 
; ਭ ࠭  ᥫ
ScreenLength equ 640 
;  ࠭, ப
ScreenHeigth equ 480 

;  䠩 ᪨ 祭 梥⮢
include "lst_1_05.inc"


DATASEG
; ⮢ ᮮ饭
Txt1 DB 0,9,"   256- PCX- "
     DB "  TRUECOLOR32",0
     DB 29,29,"  ",0
WrtFontErr DB LIGHTRED,12,23
           DB "訡   䠩 font0.fnt",0
NoFontFile DB LIGHTRED,12,16,"訡:  㤠 "
           DB " 䠩  font0.fnt",0
PrKbButton DB YELLOW,24,29,"  ",0
;  䠩 PCX
FileName      DB 'font0.pcx',0
;   ⮣ 䠩
FileHandle    DW ?
;  䠩
FileSize      DW ?
;  뢮 ப ࠦ
CurrentString DW ?
; ਭ ࠦ
ImageLength   DW ?
;  ࠦ
ImageHeigth   DW ?
; 饭 ⠡   砫 PCX-䠩
PaletteOffset DW ?
ENDS


SEGMENT sseg para stack 'STACK'  
        DB 400h DUP(?)
ENDS


;   PCX-䠩
SEGMENT FILEBUF para public  'DATA'  
        DB 0FFFFh DUP(?)
ENDS


CODESEG
;*****************************
;* ᭮  ணࠬ *
;*****************************
PROC ShowPCXFile
        mov     AX,DGROUP
        mov     DS,AX
; ⠭ ⥪⮢ ०
        mov     AX,3
        int     10h
; "墠" ⥪⮢ 
        call    GrabRusFont
; ⠭ ०
        call    SetTrueColor32
; ⠭ ० אַ 樨 
        call    Initialization

; ⠭  梥 䮭
        mov     [dword ptr DefaultBackground],404040h
; ⠭  梥 ⥪
        mov     [dword ptr DefaultColor],0FFFFFFh
;  ࠭   梥 䮭
        mov     ECX,ScreenHeigth
        shl     ECX,10
        mov     EDI,[LinearVideoBuffer]
        mov     EAX,[DefaultBackground]
@@NPix: mov     [GS:EDI],EAX
        add     EDI,4
        dec     ECX
        jnz     @@NPix
; ⮡ࠧ ⥪⮢ ᮮ饭
        mov     SI,offset Txt1
        call    GShowString
        call    GShowString

;   ᪠  ⮡ࠧ PCX-䠩
        call    PCX256inTrueColor32Mode

@@End:  ; ⠭ ⥪⮢ ०
        mov     AX,3
        int     10h
        ; 室  DOS
        mov     AH,4Ch
        int     21h
ENDP ShowPCXFile


;***********************************
;*  PCX-   FILEBUF *
;***********************************
PROC ReadPCXFile NEAR
        pusha
;  ६
        mov     [FileHandle],0
        mov     [FileSize],0
;  䠩  ⥭
        mov     AH,3Dh
        mov     AL,0
        mov     DX,offset FileName
        int     21h
        jc      @@Err
        mov     [FileHandle],AX   ; Handle
;   䠩, ⠭ 㪠⥫   
        mov     AH,42h
        mov     AL,2
        mov     BX,[FileHandle]
        xor     CX,CX
        xor     DX,DX
        int     21h
        jc      @@Err
        cmp     DX,0
        jne     @@Err  ;ࠧ 䠩 ॢ蠥 64 
        ;  ࠧ 䠩
        mov     [FileSize],AX
;  㪠⥫  砫 䠩
        mov     AH,42h
        mov     AL,0
        mov     BX,[FileHandle]
        xor     CX,CX
        xor     DX,DX
        int     21h
        jc      @@Err
;  䠩   FILEBUF
        mov     BX,[FileHandle]
        pusha     
        push    DS
        mov     AX,FILEBUF
        mov     DS,AX
        xor     DX,DX
        mov     CX,8000h
        mov     AH,3Fh
        int     21H
        pop     DS
        popa
        jc      @@Err
;  䠩
        mov     AH,3Eh
        mov     BX,[FileHandle]
        int     21H
        jc      @@Err
        popa
        ret
; ਩ 室 - 訡  ⥭ 䠩
@@Err:  ; ⠭ ⥪⮢ ०
        mov     AX,3
        int     10h
        ;  
        mov     [ScreenString],25
        mov     [ScreenColumn],0
        call    SetCursorPosition
        ; 뤠 ᮮ饭  訡
        mov     SI,offset NoFontFile
        call    ShowColorString
        mov     SI,offset PrKbButton
        call    ShowColorString
        call    GetChar
        ; 室  DOS
        mov     AH,4Ch
        int     21h
ENDP ReadPCXFile


;***********************************************
;*  PCX-   TRUECOLOR *
;***********************************************
PROC PCX256inTrueColor32Mode NEAR
        pushad
;  䠩
        call    ReadPCXFile
; ந  ॣ஢ ES:SI   ࠦ
        mov     AX,FILEBUF
        mov     ES,AX
        mov     SI,128
; ᫨ ਭ   ࠦ
        mov     AX,[ES:42h]
        mov     [ImageLength],AX
        mov     AX,[ES:0Ah]
        sub     AX,[ES:6]
        inc     AX
        mov     [ImageHeigth],AX
; ᫨ ᬥ饭   砫 䠩
        mov     AX,[FileSize]
        sub     AX,768
        mov     [PaletteOffset],AX
; ந EDI  
        ; ⠭  ⢥ 砫쭮 ப
        ; ࠦ 64- ப 
        mov     EDI,64
        shl     EDI,12
        ; ਡ  
        add     EDI,[LinearVideoBuffer]

;   ப ࠦ
@@StringStart:
        mov     DX,[ImageLength]
        push    EDI
@@NextDataByte:
        ;   CX 
        mov     CX,1
        mov     AL,[ES:SI]
        inc     SI
        ; ஢ ਧ ⮣,   
        ; 稪 ᥫ
        test    AL,10000000b
        jz      @@LoadRealColor
        test    AL,1000000b
        jz      @@LoadRealColor
        ;  稪  CX
        and     AL,111111b
        mov     CL,AL
        xor     CH,CH
        ;   AL  梥
        mov     AL,[ES:SI]
        inc     SI
;   ⠡  ॠ 祭
; 梥⮢ 
@@LoadRealColor:
        ;   梥  3    BX
        xor     AH,AH
        mov     BX,AX
        shl     AX,1
        add     BX,AX
        ; ਡ  BX ᬥ饭 ⠡
        add     BX,[PaletteOffset]
        ;   EAX 梥,  㧪 
        ; 冷   
        xor     EAX,EAX
        mov     AX,[ES:BX]
        xchg    AL,AH
        shl     EAX,8
        mov     AL,[ES:BX+2]
; ३  ᫥饬 ᥫ
@@NextPixel:
        mov     [GS:EDI],EAX
        add     EDI,4
        dec     DX
        jz      @@NextString
        loop    @@NextPixel
        jmp short @@NextDataByte
; ३  ᫥饩 ப
@@NextString:
        pop     EDI
        add     EDI,4*LogicalStringLength
        dec     [ImageHeigth]
        jnz     @@StringStart ; 譥 横

;    
        call    GetChar
        popad
        ret
ENDP PCX256inTrueColor32Mode
ENDS

;  楤    뢮  ࠭
;  ⥪⮢ ०
include "lst_1_02.inc"
;  ணࠬ, ॢ ᥣ
; ॣ GS  ०  樨
include "lst_2_01.inc"
;   楤 饣 祭,
; ।祭  ⠭ ᪨
; ०  ࠡ  
include "lst_4_02.inc"
;   楤 뢮 ⥪,
; ।祭  ० TrueColor32
include "lst_4_07.inc"

END
