;                      6.6
;   ᬮ ᥪ஢  ᪠  ᪮ "A:"
;                 㭪権 BIOS
;
;  ⥪ ணࠬ 㫠  쥢.
;  lst_6_06.asm, 24.04.2000.

IDEAL
P386
LOCALS
MODEL MEDIUM

;  䠩 ᪨ 祭
;  ࠢ 
include "lst_1_03.inc"
;  䠩 ᪨ 祭 梥⮢
include "lst_1_05.inc"

DATASEG
; ⮢ ᮮ饭
Txt0 DB LIGHTCYAN,0,7,"   "
     DB "BIOS     ",0
     DB LIGHTGREEN,12,24
     DB "⠭ ᪥  ᪮ A:",0
     DB YELLOW,24,29,"  ",0
Txt1 DB LIGHTCYAN,0,10,"ᬮ ᥪ஢ "
     DB " ᪠, 室饣  ᪮ A:",0
     DB LIGHTGREEN,2,14,"    孮(),"
     DB "    ᥪ஢  ஦",0
     DB LIGHTCYAN,17,8,"ࠢ騥 :",0
     DB YELLOW,24,27," ࠢ ",0
Txt2 DB 19,8,"५  - ᫥騩 ᥪ;",0
     DB 20,8,"५  - ।騩 ᥪ;",0
     DB 21,8,"Esc - 室.",0
Txt3 DB LIGHTGREEN,5,8
     DB "஦ N     N     N    ",0
TErr DB LIGHTRED,12,20
     DB "訡 뢠 ᥪ  ᪮ A:",0
     DB YELLOW,24,29,"  ",0

;  뢠 ᥪ  ० CHS
Cylinder    DB ?  ; 樫
Head        DB ?  ; 
Sector      DB ?  ; ᥪ
; । 祭 न
MaxCylinder DB 79 ;?  ;ᨬ  樫
MaxHead     DB 1  ;?  ;ᨬ  
MaxSector   DB 18 ;?  ;ᨬ  ᥪ

;    ࠭ ⠭ ᥪ
SectorDataBuffer DB 512 DUP (?)
ENDS


SEGMENT sseg para stack 'STACK'
        DB 400h DUP(?)
ENDS


CODESEG
;*****************************
;* ᭮  ணࠬ *
;*****************************
PROC ShowFDDSector
        mov     AX,DGROUP
        mov     DS,AX
; ⠭ ⥪⮢ ०   ࠭
        mov     AX,3
        int     10h
;   -    ࠭ ࠭
        mov     [ScreenString],25
        mov     [ScreenColumn],0
        call    SetCursorPosition
; 뢥  ࠭ ᮮ饭 "⠢ ᪥"
        mov     SI,offset Txt0
        call    ShowColorString
        call    ShowColorString
        call    ShowColorString
        ;   
        call    GetChar
;  BOOT-ᥪ ᪥
        mov     [Cylinder],0
        mov     [Head],0
        mov     [Sector],1
        call    ReadFDDSector
; ।   ࠬ ᪥
        mov     AL,[SectorDataBuffer+18h]
        mov     [MaxSector],AL
        mov     AL,[SectorDataBuffer+1Ah]
        dec     AL
        mov     [MaxHead],AL

;  ࠭
        call    ClearScreen
; 뢥 ⥪⮢ ᮮ饭
        mov     SI,offset Txt1
        call    ShowColorString
        call    ShowColorString
        call    ShowColorString
        call    ShowColorString
; ⠭  梥   䮭
        mov     [TextColorAndBackground],LIGHTGREEN
; ⮡ࠧ ࠬ ⠭ ᪥
        mov     [ScreenString],2
        mov     [ScreenColumn],25
        mov     AL,[MaxHead]
        inc     AL
        call    ShowDecByte
        mov     [ScreenColumn],43
        mov     AL,[MaxSector]
        call    ShowDecByte
; 뢥 ᠭ ࠢ 
        mov     SI,offset Txt2
        call    ShowString
        call    ShowString
        call    ShowString

;   
        mov     AX,0B800h
        mov     ES,AX     
@@ReadSector:
        mov     SI,offset Txt3
        call    ShowColorString
        mov     [ScreenString],5
        mov     [ScreenColumn],18
        mov     AL,[Cylinder]
        call    ShowDecByte
        mov     [ScreenColumn],31
        mov     AL,[Head]
        call    ShowDecByte
        mov     [ScreenColumn],44
        mov     AL,[Sector]
        call    ShowDecByte
;  ᥪ
        call    ReadFDDSector
; ⮡ࠧ  ࠭ ᮤন ⠭ ᥪ
;  ASCII-
@@ShowSector:
        ; ⠭ 砫  ⮡ࠦ ᥪ
        mov     DI,7*160+8*2
        mov     SI,offset SectorDataBuffer
        ;   ᨬ ᢥ⫮-㡮
        ; 梥  ᨭ 䮭
        mov     AH,LIGHTCYAN+BLUE*16
        mov     DX,8  ;稪 ப
@@OutNextString:
        mov     CX,64 ;稪 ᨬ  ப
@@OutNextChar:
        lodsb
        stosw
        loop    @@OutNextChar
        add     DI,16*2
        dec     DX
        jnz     @@OutNextString

@@GetCommand:
        ;   ᫥饩 
        call    GetChar
        cmp     AL,0
        je      @@TestCommandByte
        call    Beep
        jmp short @@GetCommand

@@TestCommandByte:
        cmp     AH,B_Esc     ; "室"?
; 믮  "室"
        je      @@End
@@TestDn:
        cmp     AH,B_DN
        jne     @@TestUp
; 믮  "५ "
        mov     AL,[Sector]
        cmp     AL,[MaxSector]
        jae     @@IncHead
        ;   1  ᥪ
        inc     [Sector]
        jmp     @@ReadSector
@@IncHead:
        mov     AL,[Head]
        cmp     AL,[MaxHead]
        jae     @@IncCylinder
        ;   1  ,
        ; ⠭ ᥪ 1
        inc     [Head]
        mov     [Sector],1
        jmp     @@ReadSector
@@IncCylinder:
        mov     AL,[Cylinder]
        cmp     AL,[MaxCylinder]
        jae     @@CommandError
        ;   1  樫, ⠭
        ;  0, ᥪ 1
        inc     [Cylinder]
        mov     [Head],0
        mov     [Sector],1
        jmp     @@ReadSector
@@TestUp:
        cmp     AH,B_UP
        jne     @@CommandError
; 믮  "५ "
        cmp     [Sector],1
        jbe     @@DecHead
        ;   1  ᥪ
        dec     [Sector]
        jmp     @@ReadSector
@@DecHead:
        mov     AL,[Head]
        cmp     AL,0
        je      @@DecCylinder
        ;   1  , ⠭
        ; ᨬ  ᥪ
        dec     [Head]
        mov     AL,[MaxSector]
        mov     [Sector],AL
        jmp     @@ReadSector
@@DecCylinder:
        mov     AL,[Cylinder]
        cmp     AL,0
        je      @@CommandError
        ;   1  樫, ⠭
        ; ᨬ    ᥪ
        dec     [Cylinder]
        mov     AL,[MaxHead]
        mov     [Head],AL
        mov     AL,[MaxSector]
        mov     [Sector],AL
        jmp     @@ReadSector
@@CommandError:
        call    Beep
        jmp     @@GetCommand

@@End:  ; ⠭ ⥪⮢ ०
        mov     ax,3
        int     10h
        ; 室  DOS
        mov     AH,4Ch
        int     21h
ENDP ShowFDDSector


;**********************************************
;*                 *
;* ࠬ । १       *
;* ६:                                *
;* Cylinder -  樫 ( 0  79);    *
;* Head -   (0  1);            *
;* Sector -  ᥪ ( 1  18).       *
;* ⠭ ᥪ 뢠  ᭮   *
;* ᥣ    SectorDataBuffer. *
;**********************************************
PROC ReadFDDSector NEAR
        pusha
        push    ES
        mov     AX,DS
        mov     ES,AX
        mov     CX,3   ;稪 ७
@@Repeat:
        mov     BX,offset SectorDataBuffer
        mov     AH,2   ;㭪 " ᥪ"
        mov     AL,1   ; 1 ᥪ
        mov     CH,[Cylinder]
        mov     CL,[Sector]
        mov     DH,[Head]
        mov     DL,0   ;  "A:"
        int     13h
        jnc     @@End
        ; 訡 뢠, 樠஢ ⥬
        mov     AH,0   ;㭪 "樠஢"
        mov     DL,0   ; "A:"
        int     13h
        loop    @@Repeat
        ; ⠫쭠 訡
        jmp     @@Err
; ଠ쭮 襭 楤
@@End:  pop     ES
        popa
        ret
; ਩ 室 - 訡  ⥭ 䠩
@@Err:  ;  ࠭
        call    ClearScreen
        ; 뤠 ᮮ饭  訡
        mov     SI,offset TErr
        call    ShowColorString
        call    ShowColorString
        call    GetChar
        ; 室  DOS
        mov     AH,4Ch
        int     21h
ENDP ReadFDDSector
ENDS

;  楤 뢮   ࠭
include "lst_1_02.inc"
;  楤 ॢ ᥫ   
include "lst_2_05.inc"

END
